%define sourcedir stable/%{version}/distribution/tar/generic/source
%define is_release 1
%define beta %{nil}
%define rel 4
%define DATE 20010828
Version: 2.2.2
%define ver %{version}%{beta}

Name: kdeadmin
Prefix: /usr
Obsoletes: kpackage
%if %{is_release}
Source: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{ver}.tar.bz2
%if "%{beta}" != ""
Release: 0.%{beta}.%{rel}
%else
Release: %{rel}
%endif
%else
Source: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{DATE}.tar.bz2
Release: 0.cvs%{DATE}.%{rel}
%endif
Source1: control-panel-4.1.2.tar.bz2
Source2: qmkbootdisk-1.0.0.tar.bz2
Source3: kwuftpd.pam
Source4: kwuftpd.pamd
Source5: kuser.pam
Source6: kuser.pamd
Source7: kpackage.pam
Source8: kpackage.pamd
Patch1: kdeadmin-2.1-kcron-workaround.patch
Patch2: kdeadmin-2.2-kuserconfig.patch
Patch3: kdeadmin-kpackage.patch
Summary: Administrative tools for KDE.
Epoch: 7
Group: User Interface/Desktops
BuildRoot: %{_tmppath}/%{name}-buildroot
License: GPL
Prereq: /sbin/ldconfig
Requires: qt kdelibs usermode
%ifnarch ia64 s390 s390x alpha
Requires: mkbootdisk
%endif
BuildRequires: qt-devel >= 2.3.0 zlib-devel XFree86-devel kdelibs-devel >= 2.2.2 kdelibs-sound-devel libjpeg-devel libpng-devel rpm-devel bzip2-devel db1-devel fam-devel

%description
The kdeadmin package includes administrative tools for the K Desktop
Environment (KDE), including kpackage, kdat, and kwuftpd.

%prep
rm -rf $RPM_BUILD_ROOT

%if %{is_release}
%setup -q -n %{name}-%{ver} -a 1
%else
%setup -q -n %{name} -a 1
%endif
rm -rf secpolicy
%patch1 -p1 -b .kcron
%patch2 -p1 -b .kuserconfig
%patch3 -p1 -b .kpackage

ln admin/lt* .
make -f Makefile.cvs

cd control-panel
find . -type f |xargs perl -pi -e "s,control-panel,kontrol-panel,g;s,control_panel,kontrol_panel,g;s,Control Panel,KDE Control Panel,g"
for i in control-panel* */control-panel*; do
	mv $i `echo $i |sed -e s/control-panel/kontrol-panel/g` 
done
make -f Makefile.cvs
cd ..

%ifnarch ia64 s390 s390x alpha
tar xjf %{SOURCE2}
%endif

%build
export KDEDIR=%{prefix}
export PATH=$KDEDIR/bin:$PATH
unset QTDIR || : ; . /etc/profile.d/qt.sh
if [ -x /usr/bin/getconf ]; then
  CPUS=`getconf _NPROCESSORS_ONLN`
fi
if test "x$CPUS" = "x" -o "x$CPUS" = "x0"; then
  CPUS=1
fi

cd control-panel
%configure --prefix=/usr
make -j $CPUS
cd ..

CFLAGS="-D_GNU_SOURCE $RPM_OPT_FLAGS -fno-rtti -fno-exceptions -fno-check-new -DNDEBUG -DNO_DEBUG" \
CXXFLAGS="-D_GNU_SOURCE $RPM_OPT_FLAGS -fno-rtti -fno-exceptions -fno-check-new -DNDEBUG -DNO_DEBUG" \
./configure \
	--with-rpm \
	--prefix=%{prefix} \
	--enable-final \
	--with-private-groups
make -j $CPUS
%ifnarch ia64 s390 s390x alpha
cd qmkbootdisk-1.0.0
perl -pi -e "s,-I,$RPM_OPT_FLAGS -I,g" Makefile
make
%endif

%install
make install DESTDIR=$RPM_BUILD_ROOT
cd control-panel
make install DESTDIR=$RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT/etc/skel/.gnome-desktop
mv $RPM_BUILD_ROOT/usr/bin/*kontrol-panel $RPM_BUILD_ROOT/usr/bin/kontrol-panel
mv $RPM_BUILD_ROOT/etc/X11/applnk/System/kontrol-panel.desktop $RPM_BUILD_ROOT/usr/share/applnk/System
mkdir -p $RPM_BUILD_ROOT/usr/share/apps/kdesktop/DesktopLinks
install -c -m 644 scripts/kontrol-panel.desktop $RPM_BUILD_ROOT/usr/share/apps/kdesktop/DesktopLinks/
%ifnarch ia64 s390 s390x alpha
cd ../qmkbootdisk-1.0.0
mkdir -p $RPM_BUILD_ROOT%{prefix}/bin $RPM_BUILD_ROOT/etc/X11/applnk/System
install -m 755 qmkbootdisk $RPM_BUILD_ROOT%{prefix}/bin
install -m 644 qmkbootdisk.desktop $RPM_BUILD_ROOT/etc/X11/applnk/System
install -m 644 qmkbootdisk.desktop $RPM_BUILD_ROOT/usr/share/kontrol-panel
perl -pi -e "s,redhat/shadowman-round-48.png,3floppy_unmount.png,g" $RPM_BUILD_ROOT/usr/share/kontrol-panel/qmkbootdisk.desktop
cd ..
%endif

# don't use, just delete
rm -rf $RPM_BUILD_ROOT/etc/pam.d $RPM_BUILD_ROOT/etc/security

# fix absolute symbolic links
(
  mkdir -p $RPM_BUILD_ROOT%{prefix}/share/doc/HTML/en/common
  cd $RPM_BUILD_ROOT%{prefix}/share/doc/HTML/en
  for i in kcron kpackage ksysv kuser kwuftpd ; do
    cd $i && ln -nfs ../common .
    cd ..
  done
)

# Put in some sane defaults
mkdir -p $RPM_BUILD_ROOT/usr/share/config
cat >$RPM_BUILD_ROOT/usr/share/config/kuserrc <<EOF
[template]
copySkel=true
createHomeDir=true
homeBase=/home
shell=/bin/bash
userPrivateGroup=true
EOF
cat >$RPM_BUILD_ROOT/usr/share/config/ksysvrc <<EOF
[Other Settings]
Configured=true
[Path Settings]
RunlevelPath=/etc/rc.d
ScriptPath=/etc/rc.d/init.d
[Runlevels]
Show Runlevels=0,1,2,3,4,5,6
EOF
cat >$RPM_BUILD_ROOT/usr/share/config/kpackagerc <<EOF
[Kpackage]
BSD=false
DEBAPT=false
DEBDPKG=false
KISS=false
RPM=true
SLACK=false

[Rpm]
Package_L_0_0=/mnt/cdrom/RedHat/RPMS
Package_L_0_1=/mnt/cdrom/SRPMS
Package_L_0_2=/usr/src/redhat/RPMS
Package_L_0_3=/usr/src/redhat/SRPMS
Package_L_0_4=ftp://ftp.redhat.com/pub/redhat/linux/updates/7.2/en
Package_L_1_0=ftp://rhcontrib.bero.org/pub/rh-contrib/7.2/%{_arch}
Package_L_1_1=ftp://rhcontrib.bero.org/pub/rh-contrib/7.2/noarch
Package_L_1_2=ftp://rhcontrib.bero.org/pub/rh-contrib/7.2/SRPMS
Package_S_0_0=0
Package_S_0_1=0
Package_S_0_2=1
Package_S_0_3=0
Package_S_0_4=1
Package_S_1_0=0
Package_S_1_1=0
Package_S_1_2=0
Package_U_0_0=1
Pacakge_U_0_1=1
Package_U_0_2=1
Pacakge_U_0_3=1
Package_U_0_4=0
Package_U_1_0=0
Package_U_1_1=0
Package_U_1_2=0
EOF

# Run kwuftpd and kuser through consolehelper
mkdir -p $RPM_BUILD_ROOT/etc/security/console.apps $RPM_BUILD_ROOT/etc/pam.d \
         $RPM_BUILD_ROOT/usr/sbin

install -c -m 644 %{SOURCE3} $RPM_BUILD_ROOT/etc/security/console.apps/kwuftpd
install -c -m 644 %{SOURCE4} $RPM_BUILD_ROOT/etc/pam.d/kwuftpd
install -c -m 644 %{SOURCE5} $RPM_BUILD_ROOT/etc/security/console.apps/kuser
install -c -m 644 %{SOURCE6} $RPM_BUILD_ROOT/etc/pam.d/kuser
install -c -m 644 %{SOURCE7} $RPM_BUILD_ROOT/etc/security/console.apps/kpackage
install -c -m 644 %{SOURCE8} $RPM_BUILD_ROOT/etc/pam.d/kpackage

mv $RPM_BUILD_ROOT/usr/bin/kwuftpd $RPM_BUILD_ROOT/usr/bin/kuser \
   $RPM_BUILD_ROOT/usr/bin/kpackage $RPM_BUILD_ROOT/usr/sbin

ln -s consolehelper $RPM_BUILD_ROOT/usr/bin/kwuftpd
ln -s consolehelper $RPM_BUILD_ROOT/usr/bin/kuser
ln -s consolehelper $RPM_BUILD_ROOT/usr/bin/kpackage

# remove redundant
rm -f $RPM_BUILD_ROOT/usr/share/kontrol-panel/date.desktop \
      $RPM_BUILD_ROOT/usr/share/kontrol-panel/timeconfig.desktop

%ifnarch %{ix86}
rm -f $RPM_BUILD_ROOT/usr/share/kontrol-panel/lilo.desktop \
      $RPM_BUILD_ROOT/usr/share/kontrol-panel/qmkbootdisk.desktop \
      $RPM_BUILD_ROOT/etc/X11/applnk/System/qmkbootdisk.desktop
%endif

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{name}

%files
%defattr(-,root,root)
%config /usr/share/apps/kdesktop/DesktopLinks/kontrol-panel.desktop
%config /usr/share/config/*
%ifnarch ia64 s390 s390x alpha
%config(noreplace) /etc/X11/applnk/System/*
%endif
%config(noreplace) /etc/pam.d/*
%config(noreplace) /etc/security/console.apps/*
%{prefix}/bin/*
%{prefix}/sbin/*
%{prefix}/lib/*.*
%ifarch %{ix86}
%{prefix}/lib/kde2/*
%endif
%{prefix}/share/applnk/Settings/System/*
%{prefix}/share/applnk/System/*
%{prefix}/share/apps/*
%{prefix}/share/icons/*/*/*/*
%{prefix}/share/kontrol-panel
%{prefix}/share/mimelnk/application/*
%{prefix}/share/mimelnk/text/*
%{prefix}/share/pixmaps/*
%lang(de) %{prefix}/share/locale/de/LC_MESSAGES/kontrol-panel.mo
%doc %{_docdir}/HTML

%changelog
* Wed Apr 24 2002 Than Ngo <than@redhat.com> 2.2.2-4
- usemode for kpackage (#64011)

* Fri Feb  8 2002 Bernhard Rosenkraenzer <bero@redhat.com> 2.2.2-3
- Rebuild with new rpm

* Thu Nov 15 2001 Than Ngo <than@redhat.com> 2.2.2-2
- fixed rpmdepcheck bug in kpackage (bug #55247)
- get rid of some desktop files for s390/s390x (bug #54210, #55186)

* Thu Nov 15 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2.2-1
- 2.2.2

* Sat Sep 15 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2.1-1
- 2.2.1

* Thu Aug 30 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-8
- Fix Japanese support in kontrol-panel (#52793)

* Wed Aug 29 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-7
- Rebuild with current kdelibs
- Add kpackagerc

* Tue Aug 28 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-6
- Make kontrol-panel look for applications in $PATH (#52642)
- Show QMkBootDisk in kontrol-panel

* Fri Aug 24 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-5
- Fix #50384

* Fri Aug 24 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-4
- Fix kpackage build with rpm >= 4.0.3-0.90 - the previous build
  simply built kpackage without rpm support because it couldn't find
  a matching rpmlib.

* Sun Aug 12 2001 Than Ngo <than@redhat.com> 2.2-3
- don't requires mkbootdisk on s390 s390x

* Thu Aug  9 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-2
- Get rid of the "Sources were not configured" warning at the first
  start of kuser
- The first normal user ID is 500, not 1001
- Run kwuftpd and kuser through consolehelper
- kontrol-panel 4.1.0; takes its desktop files from /etc/X11/sysconfig and
  /etc/X11/serverconfig and removes desktop files that aren't needed
  anymore
- Don't require mkbootdisk on ia64

* Mon Aug  6 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-1
- 2.2 final

* Tue Jul 24 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.cvs20010724.1
- Add build dependency on fam-devel (#49081)
- Get rid of ia64 workaround

* Sun Jul 22 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.cvs20010722.1
- Update
- Work around ia64 breakages

* Wed Jun 27 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.cvs20010627.1
- Update
- Add build dependencies (#45153)
- Don't own /usr/lib/kde2, kdelibs already does

* Tue May 22 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.alpha2.1
- 2.2alpha2

* Fri Apr 20 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.alpha1.1
- 2.2alpha1

* Fri Mar 23 2001 Preston Brown <pbrown@redhat.com> 2.1.1-3
- secpolicy removed for now...broken and useless.

* Wed Mar 21 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.1.1-2
- Fix an endless loop when switching kernels in lilo-config

* Tue Mar 20 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.1.1-1
- 2.1.1
- clean up specfile

* Mon Mar 19 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.1-8
- Don't crash when deleting a cronjob (#31999)

* Mon Mar 19 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.1-7
- Fix ksysv defaults (#32000)

* Fri Mar 16 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix kuser defaults (#31847)

* Wed Feb 28 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix typo in kontrol-panel.desktop (#30001)
- Don't own standard directories
- Add Polnish translation to .desktop files from CVS

* Sun Feb 25 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add icons for lilo and wu-ftpd configuration in kontrol-panel
  (Bug #29347)

* Wed Feb 21 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to 2.1-respin

* Mon Feb 19 2001 Than Ngo <than@redhat.com>
- fixed dangling symlinks
- fixed kontrol-panel references lprngtool (bug #25477)
- update to 2.1

* Mon Feb  5 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Rebuild with lilo installed in the buildroot, we want
  lilo-config

* Mon Jan 22 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update

* Mon Jan  1 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update
- Don't exclude ia64

* Sat Oct 28 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to KDE_2_0_BRANCH, now that the ".0 release" bugs are fixed

* Mon Oct 16 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0 final

* Tue Oct  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0

* Mon Oct  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new CVS

* Thu Aug 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild with new Qt

* Wed Aug 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.93
- fix up rpmv4 support

* Wed Jul 26 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Handle rpmv4 packages in kpackage (patch from Jeff Johnson <jbj@redhat.com>
  and myself)

* Fri Jul 21 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- some fixes to spec file

* Tue Jul 18 2000 Than Ngo <than@redhat.de>
- rebuilt against glibc-2.1.92-14, gcc-2.96-40

* Sun Jul 16 2000 Than Ngo <than@redhat.de>
- use gcc 2.96
- new snapshot
- FHS fixes

* Sun Jul  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- use kernelcc
- new snapshot

* Tue Jun 20 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- clean up specfile
- new snapshot
- ExcludeArch ia64 for now - kdelibs doesn't compile there
- kill ksysctrl for now - compiler breakages.

* Sat Mar 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- move it to /usr, where it belongs

* Fri Jan  7 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- work around install-strip breakage

* Fri Oct 22 1999 Bernhard Rosenkraenzer <bero@redhat.de>
- 2.0 snapshot
